DECLARE SUB openFile ()
DECLARE SUB drawVideoBufferPart (x%, y%, w%, h%)
DECLARE SUB bufferMainWindow ()
DECLARE SUB drawVideoBuffer ()
DECLARE SUB saveBackground (x%, y%, w%, h%)
DECLARE SUB newDoorsGroup ()
DECLARE SUB drawMenu (x%, y%, w%, h%, menuColor%)
DECLARE SUB closeMenu (menu$)
DECLARE SUB enableMenu (menu$)
DECLARE SUB disableMenu (menu$)
DECLARE SUB openFileMain ()
DECLARE SUB drawMainWindow ()
DECLARE SUB openTUI ()
DECLARE SUB drawWindow (x%, y%, w%, h%, title$)

DECLARE SUB cleanUp ()
DECLARE SUB init ()
DECLARE SUB login ()

CONST TRUE = 1
CONST FALSE = 0

TYPE buffer
  charColor AS INTEGER
  char AS STRING * 1
END TYPE


DIM SHARED colRes AS INTEGER
DIM SHARED rowRes AS INTEGER
DIM SHARED bgColor AS INTEGER
DIM SHARED bgColorMain AS INTEGER
DIM SHARED titleColor AS INTEGER
DIM SHARED loggedIn AS INTEGER
DIM SHARED videoBuffer(1 TO 80, 1 TO 45) AS buffer



CALL init
CALL login
CALL openTUI

WHILE loggedIn = TRUE
  a$ = INKEY$
  
  SELECT CASE a$

    CASE "F"
    CASE "f"
      CALL openFileMain
    CASE "q"
      loggedIn = FALSE

  END SELECT

WEND


CALL cleanUp

END

SUB bufferMainWindow

'---------------------SAVE BASIC WINDOW TO BUFFER-------------------
FOR x% = 1 TO colRes
  FOR y% = 1 TO rowRes
    videoBuffer(x%, y%).char = ""
    videoBuffer(x%, y%).charColor = titleColor
  NEXT y%
NEXT x%

FOR x% = 1 TO colRes
  FOR y% = 2 TO rowRes
    videoBuffer(x%, y%).char = ""
    videoBuffer(x%, y%).charColor = bgColorMain
  NEXT y%
NEXT x%

'--------------------TUI HEADING TEXT--------------------------

videoBuffer((colRes / 2 - 5), 1).charColor = 15
videoBuffer((colRes / 2 - 5), 1).char = "D"
videoBuffer((colRes / 2 - 4), 1).charColor = 15
videoBuffer((colRes / 2 - 4), 1).char = "o"
videoBuffer((colRes / 2 - 3), 1).charColor = 15
videoBuffer((colRes / 2 - 3), 1).char = "o"
videoBuffer((colRes / 2 - 2), 1).charColor = 15
videoBuffer((colRes / 2 - 2), 1).char = "r"
videoBuffer((colRes / 2 - 1), 1).charColor = 15
videoBuffer((colRes / 2 - 1), 1).char = "s"

'-------------------DROP DOWN MENUS----------------------------


FOR x% = 1 TO colRes
  videoBuffer(x%, 2).charColor = 7
  videoBuffer(x%, 2).char = ""
NEXT x%

'--File--
videoBuffer(2, 2).charColor = 14
videoBuffer(2, 2).char = "F"
videoBuffer(3, 2).charColor = 7
videoBuffer(3, 2).char = "i"
videoBuffer(4, 2).charColor = 7
videoBuffer(4, 2).char = "l"
videoBuffer(5, 2).charColor = 7
videoBuffer(5, 2).char = "e"

'--Options--
videoBuffer(7, 2).charColor = 14
videoBuffer(7, 2).char = "O"
videoBuffer(8, 2).charColor = 7
videoBuffer(8, 2).char = "p"
videoBuffer(9, 2).charColor = 7
videoBuffer(9, 2).char = "t"
videoBuffer(10, 2).charColor = 7
videoBuffer(10, 2).char = "i"
videoBuffer(11, 2).charColor = 7
videoBuffer(11, 2).char = "o"
videoBuffer(12, 2).charColor = 7
videoBuffer(12, 2).char = "n"
videoBuffer(13, 2).charColor = 7
videoBuffer(13, 2).char = "s"

'--Help--
videoBuffer(15, 2).charColor = 14
videoBuffer(15, 2).char = "H"
videoBuffer(16, 2).charColor = 7
videoBuffer(16, 2).char = "e"
videoBuffer(17, 2).charColor = 7
videoBuffer(17, 2).char = "l"
videoBuffer(18, 2).charColor = 7
videoBuffer(18, 2).char = "p"

END SUB

SUB cleanUp

CLS
COLOR 7

END SUB

SUB closeMenu (menu$)

SELECT CASE menu$

  CASE "file"
    x% = 2
    y% = 3
    w% = 12
    h% = 6

END SELECT


' --------- TEMP IDEA --------------------
CALL drawVideoBufferPart(x%, y%, w%, h%)


END SUB

SUB disableMenu (menu$)

SELECT CASE menu$

  CASE "main"
    COLOR 7
    LOCATE 2, 2
    PRINT "F"

    LOCATE 2, 7
    PRINT "O"

    LOCATE 2, 15
    PRINT "H"

END SELECT

END SUB

SUB drawMenu (x%, y%, w%, h%, menuColor%)

'-------------draw body window----------------

FOR i% = 0 TO h%
  FOR i2% = 0 TO w%
    LOCATE y% + i%, x% + i2%
    COLOR menuColor%
    PRINT ""
  NEXT i2%
  LOCATE y% + i%, x% + i2%
  PRINT ""
NEXT i%

'------------draw bottom line shadow----------
FOR i% = 1 TO w% + 1
  LOCATE y% + h% + 1, x% + i%
  COLOR menuColor%
  PRINT ""
NEXT i%

END SUB

SUB drawVideoBuffer

'------------dumps the video buffer onto the screen.----------------


FOR x% = 1 TO colRes
  FOR y% = 1 TO rowRes
    LOCATE y%, x%
    COLOR videoBuffer(x%, y%).charColor
    PRINT videoBuffer(x%, y%).char
  NEXT y%
NEXT x%

END SUB

SUB drawVideoBufferPart (x%, y%, w%, h%)

'------------dumps part video buffer onto the screen.----------------

w% = w% + 1
h% = h% + 2

FOR i% = 0 TO h%
  FOR i2% = 0 TO w%
    LOCATE y% + i%, x% + i2%
    COLOR videoBuffer(x%, y%).charColor
    PRINT videoBuffer(x%, y%).char
  NEXT i2%
  COLOR videoBuffer(x%, y%).charColor
  PRINT videoBuffer(x%, y%).char
NEXT i%


END SUB

SUB drawWindow (x%, y%, w%, h%, title$)


'-------------draw title bar------------------
FOR i% = 0 TO w%
  LOCATE y%, x% + i%
  COLOR titleColor
  PRINT ""
NEXT i%

'-------------insert title bar text-----------
LOCATE y%, x% + 1
COLOR 15
PRINT title$

'-------------draw body window----------------
y% = y% + 1

FOR i% = 0 TO h%
  FOR i2% = 0 TO w%
    LOCATE y% + i%, x% + i2%
    COLOR bgColor
    PRINT ""
  NEXT i2%
  LOCATE y% + i%, x% + i2%
  PRINT ""
NEXT i%


'------------draw bottom line shadow----------
FOR i% = 1 TO w% + 1
  LOCATE y% + h% + 1, x% + i%
  COLOR bgColor
  PRINT ""
NEXT i%

END SUB

SUB enableMenu (menu$)

COLOR 14

SELECT CASE menu$

  CASE "file"
    LOCATE 3, 3
    PRINT "N"
   
    LOCATE 4, 3
    PRINT "O"

    LOCATE 5, 3
    PRINT "M"

    LOCATE 6, 3
    PRINT "D"

    LOCATE 7, 3
    PRINT "P"

    LOCATE 8, 3
    PRINT "B"

    LOCATE 9, 3
    PRINT "Q"


  CASE "main"
    LOCATE 2, 2
    PRINT "F"

    LOCATE 2, 7
    PRINT "O"

    LOCATE 2, 15
    PRINT "H"

END SELECT

END SUB

SUB init

SCREEN 0
WIDTH 80, 50

titleColor = 2
bgColor = 7
bgColorMain = 8

colRes = 80
rowRes = 45

'init video buffer
FOR x% = 1 TO colRes
  FOR y% = 1 TO rowRes
    videoBuffer(x%, y%).charColor = 7
    videoBuffer(x%, y%).char = ""
  NEXT y%
NEXT x%

END SUB

SUB login

'--------------Draw login window-----------------------
CALL drawWindow(10, 10, 35, 4, "Doors Login")


'--------------Display input fields--------------------
COLOR 15
LOCATE 12, 12
PRINT "Username:                       "

COLOR 15
LOCATE 13, 12
PRINT "Password:                       "

'--------------Get user info---------------------------
LOCATE 12, 22
INPUT "", username$

LOCATE 13, 22
COLOR 0
INPUT "", password$

'-------------Check user info--------------------------

IF username$ = "erik" AND password$ = "password" THEN
  LOCATE 17, 20
  COLOR 7
  PRINT "Welcome! Loading settings..."
  loggedIn = TRUE

ELSE
  LOCATE 17, 20
  COLOR 7
  PRINT "Error: Invalid username and/or password!"
  LOCATE 18, 20
  PRINT "       ...Exiting..."
  loggedIn = FALSE

END IF


END SUB

SUB newDoorsGroup

CALL drawWindow(5, 5, 20, 10, "Set up New Group")

COLOR 7

LOCATE 7, 6
PRINT "Name:             "

LOCATE 8, 6
PRINT "Column:           "

LOCATE 9, 6
PRINT "Row:              "

LOCATE 10, 6
PRINT "Width:            "

LOCATE 11, 6
PRINT "Height:           "

LOCATE 7, 6
INPUT "Name: ", name$

LOCATE 8, 6
INPUT "Column: ", col%

LOCATE 9, 6
INPUT "Row: ", row%

LOCATE 10, 6
INPUT "Width: ", w%

LOCATE 11, 6
INPUT "Height: ", h%

'---------------CLEAN UP!-------------------
CALL drawVideoBufferPart(5, 5, 20, 10)


'----------------DRAW NEW WINDOW IF IN RANGE-----------
IF (col% + w%) < colRes% AND (row% + h%) < rowRes% THEN
  CALL drawWindow(col%, row%, w%, h%, name$)
END IF


END SUB

SUB openFile

'opens a command line.

CALL drawWindow(5, 5, 40, 2, "Open")

COLOR 7

LOCATE 7, 6
PRINT "                                      "

LOCATE 7, 6
INPUT "Command: ", cmd$


'---------------CLEAN UP!-------------------
CALL drawVideoBufferPart(5, 5, 40, 5)


'-----------------Open the file!--------------

CLS

SHELL cmd$

PRINT "Press any key to return to Doors..."
SLEEP

CALL drawVideoBuffer

END SUB

SUB openFileMain

Request% = 0
new% = 1
openf% = 2


'---------------BUFFER WHAT WILL BE COVERED------------
CALL saveBackground(2, 3, 12, 6)

'---------------DRAW BASE MENU-------------------------
CALL drawMenu(2, 3, 12, 6, bgColor)

'---------------GREY OUT MAIN MENUS--------------------
CALL disableMenu("main")

'----------------SET MENU TEXT-------------------------
COLOR 7

LOCATE 3, 4
PRINT "ew"

LOCATE 4, 4
PRINT "pen"

LOCATE 5, 4
PRINT "ove"

LOCATE 6, 4
PRINT "elete"

LOCATE 7, 4
PRINT "roperties"

LOCATE 8, 4
PRINT "ack"

LOCATE 9, 4
PRINT "uit"

'----------------ENABLE MENU LETTERS---------------------
CALL enableMenu("file")

DO
  b$ = INKEY$

  IF b$ = "n" OR b$ = "N" THEN
    Request% = new%

  ELSEIF b$ = "o" OR b$ = "O" THEN
    Request% = openf%
   
  ELSEIF b$ = "q" OR b$ = "Q" THEN
    loggedIn = FALSE

  END IF
LOOP WHILE b$ = ""

CALL closeMenu("file")

IF Request% > 0 THEN
  SELECT CASE Request%

    CASE new%
      CALL newDoorsGroup
     
    CASE openf%
      CALL openFile
 
  END SELECT
END IF

CALL enableMenu("main")

END SUB

SUB openTUI

'opens the TUI

CLS

CALL bufferMainWindow
CALL drawVideoBuffer

END SUB

SUB saveBackground (x%, y%, w%, h%)



FOR i% = 0 TO h%
  FOR i2% = 0 TO w%
    
  NEXT i2%
NEXT i%



END SUB

